-- This Source Code Form is subject to the terms of the bCDDL, v. 1.1.
-- If a copy of the bCDDL was not distributed with this
-- file, You can obtain one at http://beamng.com/bCDDL-1.1.txt

local M = {}



--main variables
local pw2_currentbullet_num
local pw2_timeBetweenBullets
local reloading
local pw2_bulletvel
local pw2_bulletsfired
local pw2_rpghit
local pw2_mag_num = {}
local pw2_direction
local pw2_playerVehicle
local selectedWeapon = "akm"
local selectedWeaponNum = 1
local pw2_timeBetweenReload
-- local pw2_mag_num_1
-- local pw2_mag_num_2
-- local pw2_mag_num_3
-- local pw2_mag_num_4
-- local pw2_mag_num_5
-- local pw2_mag_num_6

--from jbeamData
local pw2_ammo
local pw2_shoot_delay = 0
local pw2_guntype
local pw2_bulletMass = 0
local pw2_decreaseAmmoWeightOnShooting --boolean
local pw2_bulletMassInAmmo
local pw2_breakable --boolean
local pw2_breakBeamName
local pw2_hasBelt --boolean
local pw2_bulletsPerBeltSection
local pw2_beltDetachable --boolean
local pw2_beltDetachBeamName
local pw2_hasSecondaryGun --boolean
local pw2_simplifiedMode --boolean
local pw2_magsize = 0
local pw2_reloadtime = 0
local pw2_BulletAcc2
local pw2_rpg
local pw2_isInfinite
local pw2_bulletVelocity = 0
--variables for nodes
local pw2_gunSoundNode --gun sounds location
local pw2_fireParticleNodeInner --shoot particles location
local pw2_fireParticleNodeOuter --shoot particles direction
local pw2_ammoWeightStorageNode --stores the weight of the gun's ammo, more useful for flamethrower since the machine gun bullets are light
local pw2_gunSoundNode2 --gun sounds location
local pw2_fireParticleNodeInner2 --shoot particles location
local pw2_fireParticleNodeOuter2 --shoot particles direction
local pw2_explosionNode


--variables for names of the nodes from JbeamData
local pw2_gunSoundNodeID
local pw2_fireParticleNodeInnerID
local pw2_fireParticleNodeOuterID
local pw2_ammoWeightStorageNodeID
local pw2_gunSoundNodeID2
local pw2_fireParticleNodeInnerID2
local pw2_fireParticleNodeOuterID2
local pw2_explosionNodeID


local function init(jbeamData)
  guihooks.message("Activated AwesomeCarl's epic INFINITE AMMO SUPER 6000 ULTRA EFFICIENCY AMMUNITION PROPULSION SYSTEM", 2, "carlsepicthing")
  --get jbeamData
  pw2_ammo = jbeamData.pw2_ammo or 100
  --pw2_shoot_delay = jbeamData.pw2_shoot_delay or 0.075
  --pw2_bulletVelocity = jbeamData.pw2_bulletVelocity or 1
  pw2_guntype = jbeamData.pw2_guntype or "Machinegun"
  --pw2_bulletMass = jbeamData.pw2_bulletMass or 2.5
  pw2_gunSoundNodeID = "driver"
  pw2_decreaseAmmoWeightOnShooting = jbeamData.pw2_decreaseAmmoWeightOnShooting or false
  pw2_fireParticleNodeInnerID = "bc1"
  pw2_fireParticleNodeOuterID = "pw2_gun_node"

  pw2_bulletMassInAmmo = jbeamData.pw2_bulletMassInAmmo or 2.5

  pw2_gunSoundNodeID2 = "driver"
  pw2_fireParticleNodeInnerID2 = "bc1"
  pw2_fireParticleNodeOuterID2 = "pw2_gun_node"
  pw2_simplifiedMode = jbeamData.pw2_simplifiedMode or false
  --pw2_magsize = jbeamData.pw2_magsize or 1000
  --pw2_reloadtime = jbeamData.pw2_reloadtime or 3
  pw2_rpg = jbeamData.pw2_rpg or false
  pw2_explosionNodeID = jbeamData.pw2_explosionNode or "agentygunexplode"
  pw2_isInfinite = jbeamData.pw2_isInfinite or false
  pw2_forcefieldMode = jbeamData.pw2_forcefieldMode or false

  
  --reset electrics values for firing all bullets
  for i=1, pw2_ammo, 1 do
    electrics.values["shootbullet_" .. i] = 0
  end
  
  --reset other electrics
  electrics.values['pw2_fire'] = 0
  electrics.values['pw2_reload'] = 0
  electrics.values['pw2_gun_lift'] = 0
  electrics.values['pw2_gun_lift_input'] = 0
  electrics.values['pw2_weaponUp'] = 0
  electrics.values['pw2_weaponDown'] = 0
  electrics.values.shootnum = 0
  
  --reset local variables
  pw2_currentbullet_num = 1
  pw2_timeBetweenBullets = 0
  reloading = 0
  pw2_mag_num[0] = 0
  pw2_mag_num[1] = 0
  pw2_mag_num[2] = 0
  pw2_mag_num[3] = 0
  pw2_timeBetweenReload = 0
  pw2_currentbullet_num = 1
  pw2_rpgboom = false
  pw2_rpgreset = 0
  pw2_bulletsfired = 0
  pw2_rpghit = 0
  pw2_direction = vec3(0,0,0)
  for k, node in pairs (v.data.nodes) do
    if node.name == "driver" then pw2_originalLocation = k 
    end
  end

  
  --assign nodes to variables based on IDs from jbeamData
  for k, node in pairs (v.data.nodes) do
  if node.name == pw2_gunSoundNodeID then pw2_gunSoundNode = k  end
	if node.name == pw2_fireParticleNodeInnerID then pw2_fireParticleNodeInner = k  end
	if node.name == pw2_fireParticleNodeOuterID then pw2_fireParticleNodeOuter = k  end
	if node.name == pw2_gunSoundNodeID2 then pw2_gunSoundNode2 = k  end
  if node.name == pw2_explosionNodeID then pw2_explosionNode = k  end
	if node.name == pw2_fireParticleNodeInnerID2 then pw2_fireParticleNodeInner2 = k  end
	if node.name == pw2_fireParticleNodeOuterID2 then pw2_fireParticleNodeOuter2 = k  end
  end
  
  
  --display GUI message based on gun type (this doesn't work sometimes for some reason)
  -- if pw2_guntype == "machinegun" then
	--   guihooks.message("Bullets left: " .. pw2_ammo, 5, "pw2_gun")
	-- end
  -- if reloading == 1 then
  --   guihooks.message("Reloading", 0.1, "pw2_gun")
  -- end
  for k, node in pairs (v.data.nodes) do
    --reset particle properties
    node.horizontalVelocity = nil
    node.newHorizontalVelocity = nil
    node.exploded = false
  end
end


local function updateGFX(dt) -- ms






  obj:queueGameEngineLua("local f = core_camera.getForward() be:getObjectByID(" .. obj:getID() .. "):queueLuaCommand(\"controller.getControllerSafe('pw2').camForwardCallback(\" .. tostring(f.x) .. \", \" .. tostring(f.y) .. \", \" .. tostring(f.z) .. \")\")")
  --obj:queueGameEngineLua("local veh = be:getPlayerVehicle(0); print(veh); veh:setMeshAlpha(0.5, '', false)")

  --electrics.values["shootbullet_" .. pw2_currentbullet_num - 1] = 0 -- RESET THRUSTERS FOR CARLS EPIC SYSTEM THING
--INFINITE AMMO 
--INFINITE AMMO 
--INFINITE AMMO 
--INFINITE AMMO 

guihooks.message("Magazine: " .. pw2_magsize-pw2_mag_num[0]+1 .. "/" .. pw2_magsize+1, 0.1, "pw2_mag")

  if pw2_currentbullet_num > 100 then
    pw2_currentbullet_num = 1
  end

  for k, node in pairs (v.data.nodes) do
    if node.pw2_bulletID == pw2_currentbullet_num then
    obj:setNodeMass(node.cid, 0.01)
    end
  end

  --FIRST WE MANAGE THE GUN LIFTING MECHANISM--
  electrics.values['pw2_gun_lift'] = math.min(0.9, math.max(-0.9, (-pw2_direction.z)))

  -- HIT PARTICLES (HELP WITH CODE BY AWESOMECARL) --
if not pw2_rpg then
    --track horizontal velocity for each fired node
    for k, node in pairs (v.data.nodes) do
      --check if node is a bullet and then if it has been fired already
      if node.pw2_bulletID and node.pw2_bulletID <= pw2_currentbullet_num - 1 then
        if not node.exploded then
          obj:addParticleByNodesRelative(node.cid, node.cid, 1200000, 67, 0, 10)
        end
        local velocity = vec3(obj:getNodeVelocityVector(node.cid))
        --check if node has just been fired (has no set velocity)
        if node.newHorizontalVelocity == nil then
          node.newHorizontalVelocity = (math.abs(velocity.x) + math.abs(velocity.y))
        else
          --update velocity, store old one in different variable
          node.horizontalVelocity = node.newHorizontalVelocity
          node.newHorizontalVelocity = (math.abs(velocity.x) + math.abs(velocity.y))
          if node.exploded == false then
          --check if node hit something - velocity has decreased significantly
          if pw2_forcefieldMode then
            if node.horizontalVelocity < 1 and node.horizontalVelocity > 0.01 then
              --electrics.values["shootbullet_" .. node.pw2_bulletID] = -10 --Permanent force field
            else
              --electrics.values["shootbullet_" .. pw2_currentbullet_num - 1] = 0
            end
          end
          if node.horizontalVelocity - node.newHorizontalVelocity > 0.01 then
              --add particles once
              obj:addParticleByNodesRelative(node.cid, node.cid, 12, 1, 0.0002, 1)
              obj:addParticleByNodesRelative(node.cid, node.cid, 15, 61, 0.0002, 1)
              obj:addParticleByNodesRelative(node.cid, node.cid, 10, 62, 0.0002, 1)
              obj:addParticleByNodesRelative(node.cid, node.cid, 20, 63, 0.0002, 1)
              obj:addParticleByNodesRelative(node.cid, node.cid, 8, 64, 0.0002, 1)
              obj:addParticleByNodesRelative(node.cid, node.cid, 12, 65, 0.0002, 1)
              obj:addParticleByNodesRelative(node.cid, node.cid, 10, 6, 0.0002, 1)
              obj:setNodeMass(node.cid, 0.01)
              --obj:setNodePosition(node.cid, vec3(obj:getNodePosition(pw2_originalLocation)))
              node.exploded = true
              if pw2_forcefieldMode then
                electrics.values["shootbullet_" .. node.pw2_bulletID] = -1000 --EXTREME FORCE FIELD
              end
          else
            --node.exploded = false
            end
          end
        end
      end
    end
  end

    --for k, node in pairs (v.data.nodes) do
      --check if node is a bullet and then if it has been fired already
      --if node.pw2_bulletID and node.pw2_bulletID <= pw2_currentbullet_num - 1 then
      --  local velocity = vec3(obj:getNodeVelocityVector(node.cid))
      --  --check if node has just been fired (has no set velocity)
      --  if node.newHorizontalVelocity == nil then
      --    node.newHorizontalVelocity = (math.abs(velocity.x) + math.abs(velocity.y))
      --  else
      --    --update velocity, store old one in different variable
      --    node.horizontalVelocity = node.newHorizontalVelocity
      --    node.newHorizontalVelocity = (math.abs(velocity.x) + math.abs(velocity.y))
      --    --check if node hit something - velocity has decreased significantly
      --    if node.horizontalVelocity - node.newHorizontalVelocity > 0.1 then
      --        obj:setNodePosition(node.cid, vec3(obj:getNodePosition(pw2_originalLocation)))
      --      end
      --    end
      --  end
      --end
    

    --rpg
    if pw2_rpg then
    for k, node in pairs (v.data.nodes) do
      --check if node is a bullet and then if it has been fired already
      if node.pw2_bulletID and node.pw2_bulletID == pw2_currentbullet_num - 10 then
        local velocity = vec3(obj:getNodeVelocityVector(node.cid))
        --check if node has just been fired (has no set velocity)
        if node.horizontalVelocity == nil then
          node.horizontalVelocity = (math.abs(velocity.x) + math.abs(velocity.y))
        end
        if node.newHorizontalVelocity == nil then
          node.newHorizontalVelocity = (math.abs(velocity.x) + math.abs(velocity.y))
        else
          --print("step1")
          --update velocity, store old one in different variable
          node.newHorizontalVelocity = (math.abs(velocity.x) + math.abs(velocity.y))
          if node.exploded == false then
            --print("step2")
          obj:addParticleByNodesRelative(node.cid, node.cid, 12, 25, 0, 1) -- add middair particle
          if node.horizontalVelocity - node.newHorizontalVelocity > 0.0001 and pw2_timeBetweenBullets > 0.001 then  --check if node hit something - velocity has decreased significantly
              --add particles once
              obj:setNodePosition(pw2_explosionNode, vec3(obj:getNodePosition(node.cid)))
              --explosionlocation = vec3(obj:getNodePosition(node.cid))
              --print("real location:")
              --print(explosionlocation)
              pw2_rpgboom = true
              pw2_rpghit = true
              obj:addParticleByNodesRelative(pw2_explosionNode, pw2_explosionNode, 12, 29, 0.4, 10)
              obj:addParticleByNodesRelative(pw2_explosionNode, pw2_explosionNode, 12, 9, 0.01, 6)
              obj:addParticleByNodesRelative(pw2_explosionNode, pw2_explosionNode, 12, 52, 0.01, 4)

              obj:setNodeMass(node.cid, 0.01)
              obj:setNodePosition(node.cid, vec3(obj:getNodePosition(pw2_originalLocation))) print("teleported rpgmain node to gun")  -----PROBLEM: NODES GET TOO MUCH VELOCITY, FALL THROUGH GROUND AND GET INFINITE VELOCITY SINCE THEYRE TELEPORTED BACK TO GUN. CAUSING BAD FIRING.

              node.exploded = true
              --pw2_rpgreset = pw2_rpgreset + 1
            else
              node.exploded = false
              --print("resetting exploded")
            end
            node.horizontalVelocity = node.newHorizontalVelocity
          end
        end
      end

      if node.pw2_bulletID and node.pw2_bulletID >= pw2_currentbullet_num - 9 and node.pw2_bulletID < pw2_currentbullet_num then
        local velocity = vec3(obj:getNodeVelocityVector(node.cid))
        --check if node has just been fired (has no set velocity)
        if node.horizontalVelocity == nil then
          node.horizontalVelocity = (math.abs(velocity.x) + math.abs(velocity.y))
        end
        if node.newHorizontalVelocity == nil then
          node.newHorizontalVelocity = (math.abs(velocity.x) + math.abs(velocity.y))
        else
          --print("step1")
          --update velocity, store old one in different variable
          node.newHorizontalVelocity = (math.abs(velocity.x) + math.abs(velocity.y))
          if pw2_rpghit then
          if node.exploded == false then
            --print("step2")
            if node.exploded2 ~= true then
            if node.horizontalVelocity > 1 then

            obj:addParticleByNodesRelative(node.cid, node.cid, 12, 25, 0, 1) -- add middair particle
            end
            end
          if node.horizontalVelocity - node.newHorizontalVelocity > 0.1 then  --check if node hit something - velocity has decreased significantly
            --print("step3")
              --add particles once
              obj:addParticleByNodesRelative(node.cid, node.cid, 1, 29, 0.1, 1)
              obj:addParticleByNodesRelative(node.cid, node.cid, 12, 9, 0.01, 6)
              node.exploded2 = true
              --obj:setNodeMass(node.cid, 0.01)
              --obj:addParticleByNodesRelative(node.cid, node.cid, 12, 52, 0.01, 4)
              --print(node.cid)
            end
            node.horizontalVelocity = node.newHorizontalVelocity
          end
        end
        end
      end
      if node.horizontalVelocity and node.horizontalVelocity < 0.3 then
        if not node.exploded then
          obj:setNodeMass(node.cid, 0.01)
        end
      end
    end


    for k, node in pairs (v.data.nodes) do
      if node.pw2_bulletID and node.pw2_bulletID == pw2_currentbullet_num - 10 then
        --print(node.name)
        --print(vec3(obj:getNodePosition(node.cid)))
      end
      if node.pw2_bulletID and node.pw2_bulletID >= pw2_currentbullet_num - 9 and node.pw2_bulletID < pw2_currentbullet_num then
        --print(node.pw2_bulletID)
        if pw2_rpgboom then
          if node.exploded == false then
            for _,b in pairs(v.data.beams) do
              if b.pw2_bulletID and b.pw2_bulletID >= pw2_currentbullet_num -9 and b.pw2_bulletID <= pw2_currentbullet_num -1 then
                obj:breakBeam(b.cid)
              end
            end
          obj:setNodeMass(node.cid, 240)
          obj:setNodePosition(node.cid, explosionlocation)
          local randX = math.random(20+pw2_bulletvel.x*7,-20+pw2_bulletvel.x*7) --made with help from chatgpt
          local randY = math.random(20+pw2_bulletvel.y*7,-20+pw2_bulletvel.y*7)
          --print(pw2_bulletvel)
          local randZ = math.random(-90, 90 + pw2_bulletvel.z)
          local forceVec = vec3(randX, randY, randZ)
          obj:applyForceVector(node.cid, forceVec) -- explosion
          --print(explosionlocation)
          --electrics.values["rpgexplode_" .. pw2_currentbullet_num -9] = -1
          node.exploded = true
          --pw2_rpgreset = pw2_rpgreset + 1
          end
        end
      end
    end
    for k, node in pairs (v.data.nodes) do
      if node.pw2_bulletID and node.pw2_bulletID == pw2_currentbullet_num - 10 then
        explosionlocation = vec3(obj:getNodePosition(node.cid)) --set explosionlocation after
        pw2_bulletvel = vec3(obj:getNodeVelocityVector(node.cid))
        --print(pw2_bulletvel)
      end
    end

    pw2_rpgboom = false
  for k, node in pairs (v.data.nodes) do
    if node.pw2_bulletID and node.pw2_bulletID >= pw2_currentbullet_num - 9 and node.pw2_bulletID < pw2_currentbullet_num then
      node.exploded = false
    end
  end


  end


    --print(pw2_currentbullet_num)
    if pw2_currentbullet_num > 100 then
      if pw2_rpgboom then
      --if pw2_rpgreset >= 100 then
        pw2_currentbullet_num = 1
        --pw2_rpgreset = 0
      --end
      end
    end



 
  for k, node in pairs (v.data.nodes) do ------------------------------------------------------------------------------teleport nodes when they fall off map i guess
    if node.pw2_bulletID then
      local nodepos = vec3(obj:getNodePosition(node.cid))
      if nodepos.z < -500 or nodepos.z > 500 then
        obj:setNodePosition(node.cid, vec3(obj:getNodePosition(pw2_originalLocation)))
      end
    end
  end



  -- Reload Button
  -- Reload Button
    -- Reload Button
      -- Reload Button
        -- Reload Button
          -- Reload Button
            -- Reload Button
              -- Reload Button
                -- Reload Button
                  -- Reload Button
                    -- Reload Button
                      -- Reload Button
                        -- Reload Button
  if electrics.values.pw2_reload > 0.9 then --axis/button is not being pressed down far enough, ignore this event

    if reloading == 0 then
     electrics.values['pw2_reload'] = 0   
   if pw2_mag_num[0] > 0 then

    electrics.values['pw2_reload'] = 0   
    pw2_mag_num[0] = pw2_magsize + 1
    pw2_mag_num[selectedWeaponNum] = pw2_magsize + 1
    pw2_timeBetweenReload = 0
    

   end
  end
  end


  --print(electrics.values["shootbullet_" .. pw2_currentbullet_num])





  -- CHECKING IF WE CAN SHOOT --
  if pw2_mag_num[selectedWeaponNum] > pw2_magsize then
    reloading = 1
    pw2_timeBetweenReload = pw2_timeBetweenReload + dt --measure time between firing each bullet
    --guihooks.message("Relod: " .. pw2_timeBetweenReload, 5, "pw2_gun")
    if pw2_timeBetweenReload > pw2_reloadtime then
    pw2_mag_num[0] = 0
    pw2_mag_num[selectedWeaponNum] = 0
    reloading = 0
    pw2_timeBetweenReload = 0

    guihooks.message("Reloaded", 1, "pw2_gun")
    electrics.values.pw2_lifter = 0
    electrics.values['pw2_reload'] = 0
    
    end
    end --set reloading

    if pw2_mag_num[0] > pw2_magsize then 
      if pw2_timeBetweenReload > 0.25 then
    if pw2_timeBetweenReload < 0.27 then
    obj:playSFXOnce("CrashTestSound", pw2_gunSoundNode, 0.4, 6)
    else
    if pw2_timeBetweenReload > 0.54 then
      if pw2_timeBetweenReload < 0.58 then

      obj:playSFXOnce("CrashTestSound", pw2_gunSoundNode, 0.4, 6.6)
      else
        if pw2_timeBetweenReload > pw2_reloadtime - 0.02 then
          if pw2_timeBetweenReload < pw2_reloadtime then
            obj:playSFXOnce("CrashTestSound", pw2_gunSoundNode, 0.4, 6)
      end
      end
    end
  end
end
end
end






guihooks.message("Current weapon: " .. selectedWeapon, 0.1, "pw2_currentweapon")


    if electrics.values['pw2_weaponUp'] > 0.9 then --CHANGING WEAPONS
      selectedWeaponNum = selectedWeaponNum + 1
      electrics.values['pw2_weaponUp'] = 0
      if pw2_timeBetweenReload > 0 then
        guihooks.message("Reloading cancelled", 0.5, "pw2_gun")
        reloading = 0
        pw2_timeBetweenReload = 0
      end
      --return
    end
    if electrics.values['pw2_weaponDown'] > 0.9 then
      selectedWeaponNum = selectedWeaponNum - 1
      electrics.values['pw2_weaponDown'] = 0
      if pw2_timeBetweenReload > 0 then
        guihooks.message("Reloading cancelled", 0.5, "pw2_gun")
        reloading = 0
        pw2_timeBetweenReload = 0
      end
      --return
    end


    local maxWeaponNum = 3 --Set number of weapons available
    if selectedWeaponNum > maxWeaponNum then
      selectedWeaponNum = 1
    end
    if selectedWeaponNum < 1 then
      selectedWeaponNum = maxWeaponNum
    end
--WEAPON SWITCHING SYSTEM
if selectedWeaponNum == 1 then
  selectedWeapon = "Uzi"
  pw2_shoot_delay = 1/952*60
  pw2_bulletVelocity = 1.4
  pw2_bulletMass = 7
  pw2_magsize = 31 --real value is value + 1
  pw2_reloadtime = 1.8
  pw2_mag_num[0] = pw2_mag_num[selectedWeaponNum]
  print("set mag_num[0] to mag_num of " .. selectedWeapon)
end
if selectedWeaponNum == 2 then
  selectedWeapon = "Thompson"
  pw2_shoot_delay = 1/600*60
  pw2_bulletVelocity = 1.9
  pw2_bulletMass = 9
  pw2_magsize = 49 --real value is value + 1
  pw2_reloadtime = 3.2
  pw2_mag_num[0] = pw2_mag_num[selectedWeaponNum]
  print("set mag_num[0] to mag_num of " .. selectedWeapon)
end
if selectedWeaponNum == 3 then
  selectedWeapon = "AKM"
  pw2_shoot_delay = 1/420*60
  pw2_bulletVelocity = 2.4
  pw2_bulletMass = 9
  pw2_magsize = 29 --real value is value + 1
  pw2_reloadtime = 2.7
  pw2_mag_num[0] = pw2_mag_num[selectedWeaponNum] --set magazine number to previous magazine number of this gun
  print("set mag_num[0] to mag_num of " .. selectedWeapon)
end


print(selectedWeapon .. ": " .. pw2_mag_num[selectedWeaponNum])

  pw2_timeBetweenBullets = pw2_timeBetweenBullets + dt --measure time between firing each bullet

  if not pw2_rpg then
  if pw2_timeBetweenBullets < pw2_shoot_delay then return end --can't shoot if timer is not over
  end



    if reloading == 1 then 
      guihooks.message("Reloading " .. math.floor((pw2_reloadtime-pw2_timeBetweenReload)*10)/10, 0.1, "pw2_gun")
      --guihooks.message("Relod: " .. pw2_timeBetweenReload, 5, "pw2_gun")
      electrics.values['pw2_reload'] = 0
      if pw2_timeBetweenReload > 0.1 then
      --electrics.values['pw2_gun_lift'] = 0.8
      end
      return end




  if pw2_mag_num[0] > pw2_magsize then return end


  -- DETECTING INPUT --
  if electrics.values.pw2_fire < 0.9 then return end --axis/button is not being pressed down far enough, ignore this event
  if pw2_currentbullet_num > pw2_ammo then return end -- don't shoot if we are out of ammo
  -- FIRING THE BULLETS --
    	--increase weight of each bullet on the fly
	--this is not very realistic but it's the only way we can deal damage basically
	--it increases bullet energy and keeps momentum because it slows down bullets a bit
	--and if the bullets had this weight from the start, the vehicle wouldn't be able to hold the gun due to the weight
	for k, node in pairs (v.data.nodes) do
    if node.pw2_bulletID == pw2_currentbullet_num then
    obj:setNodeMass(node.cid, pw2_bulletMass)
    end 
  end	
  -- shoot bullet nr. pw2_currentbullet_num, but only if the ammo belt is attached

    -- for _,b in pairs(v.data.beams) do
	  --   if b.pw2_bulletID == pw2_currentbullet_num then
		--   obj:breakBeam(b.cid)
		--   end
	  -- end
    for k, node in pairs (v.data.nodes) do
      if node.pw2_bulletID == pw2_currentbullet_num then
        obj:setNodePosition(node.cid, vec3(obj:getNodePosition(pw2_originalLocation)))
        print("teleported bullet to gun")
        --obj:applyForceVector(node.cid, vec3(obj:getNodeVelocityVector(pw2_fireParticleNodeInner)))
        --electrics.values["shootbullet_" .. pw2_currentbullet_num] = -1  --OLD SHOOOTING SYSTEMMMMMMMMMMMMMMMMMMMMMMMMMMMM


        obj:applyForceVector(node.cid, vec3(pw2_direction*900*pw2_bulletVelocity+obj:getVelocity())) --NEW EPIC SHOOTING THING
        print("applied force to node")









        node.exploded = false
	    end
      if node.pw2_bulletID and node.pw2_bulletID >= pw2_currentbullet_num - 9 and node.pw2_bulletID < pw2_currentbullet_num then
        node.exploded2 = false
      end
	  end

  if not pw2_rpg then
  pw2_currentbullet_num = pw2_currentbullet_num + 1 --go to next bullet in line
  else
    pw2_currentbullet_num = pw2_currentbullet_num + 10 --go to next bullet in line
    pw2_mag_num[0] = pw2_mag_num[0] + 9
    pw2_bulletsfired = pw2_bulletsfired + 9
  end
  pw2_rpghit = false
  pw2_canShoot = false --disable shooting until time passes
  pw2_timeBetweenBullets = 0 --reset timer
  pw2_bulletsLeft = pw2_ammo - pw2_currentbullet_num + 1
  electrics.values.shootnum = pw2_bulletsLeft

  pw2_mag_num[0] = pw2_mag_num[0] + 1
  pw2_mag_num[selectedWeaponNum] = pw2_mag_num[0] --only change the magazine number of the current gun
  print("mag_num of " .. selectedWeapon .. "is set to mag_num[0]")
  pw2_bulletsfired = pw2_bulletsfired + 1
  guihooks.message("Bullets fired: " .. pw2_bulletsfired, 0.1, "AgentYgunbullets")

  --Remove the weight of each node from the ammo storage weight
  if pw2_decreaseAmmoWeightOnShooting == true then 
	local currentAmmoNodeMass = obj:getNodeMass(pw2_ammoWeightStorageNode)
	local AmmoNodeMassAfterShooting = currentAmmoNodeMass - pw2_bulletMassInAmmo
	obj:setNodeMass(pw2_ammoWeightStorageNode, AmmoNodeMassAfterShooting)


end
  
    --FIRING PARTICLES
  
  if (pw2_guntype == "Machinegun") then

      obj:playSFXOnce("CrashTestSound", pw2_gunSoundNode, 1, 2)

		--show firing particles
		obj:addParticleByNodesRelative(pw2_fireParticleNodeInner, pw2_fireParticleNodeOuter, 15, 61, 0, 1)
		obj:addParticleByNodesRelative(pw2_fireParticleNodeInner, pw2_fireParticleNodeOuter, 10, 62, 0, 1)
		obj:addParticleByNodesRelative(pw2_fireParticleNodeInner, pw2_fireParticleNodeOuter, 20, 63, 0, 1)
		obj:addParticleByNodesRelative(pw2_fireParticleNodeInner, pw2_fireParticleNodeOuter, 8, 64, 0, 1)
		obj:addParticleByNodesRelative(pw2_fireParticleNodeInner, pw2_fireParticleNodeOuter, 12, 65, 0, 1)

		--show smoke
    if pw2_shoot_delay < 0.15 then
      --obj:addParticleByNodesRelative(pw2_fireParticleNodeInner, pw2_fireParticleNodeOuter, 10, 6, 0.1, 1)
    else
      obj:addParticleByNodesRelative(pw2_fireParticleNodeInner, pw2_fireParticleNodeOuter, 10, 6, 0, 1)
    end
	
	end
	
  





end

local function liftGun(value)
  electrics.values.pw2_gun_lift_input = value
end

local function camForwardCallback(fx, fy, fz)
  pw2_direction = vec3(fx, fy, fz) -- store the forward here or something idk do what you want lol
  -- you can just do vec3(fx, fy, fz) to get the forward
end

-- local function playerVehicleCallback(veh)
--   pw2_playerVehicle = veh
--   print(veh)
-- end



-- public interface

M.init         = init
M.updateGFX    = updateGFX
M.liftGun      = liftGun
M.camForwardCallback = camForwardCallback
--M.playerVehicleCallback = playerVehicleCallback

return M
